// generated from rosidl_generator_c/resource/idl__functions.c.em
// with input from ml_classifiers:srv/ClassifyData.idl
// generated code does not contain a copyright notice
#include "ml_classifiers/srv/classify_data__functions.h"

#include <assert.h>
#include <stdbool.h>
#include <stdlib.h>
#include <string.h>

// Include directives for member types
// Member `identifier`
#include "rosidl_generator_c/string_functions.h"
// Member `data`
#include "ml_classifiers/msg/class_data_point__functions.h"

bool
ml_classifiers__srv__ClassifyData_Request__init(ml_classifiers__srv__ClassifyData_Request * msg)
{
  if (!msg) {
    return false;
  }
  // identifier
  if (!rosidl_generator_c__String__init(&msg->identifier)) {
    ml_classifiers__srv__ClassifyData_Request__destroy(msg);
    return false;
  }
  // data
  if (!ml_classifiers__msg__ClassDataPoint__Sequence__init(&msg->data, 0)) {
    ml_classifiers__srv__ClassifyData_Request__destroy(msg);
    return false;
  }
  return true;
}

void
ml_classifiers__srv__ClassifyData_Request__fini(ml_classifiers__srv__ClassifyData_Request * msg)
{
  if (!msg) {
    return;
  }
  // identifier
  rosidl_generator_c__String__fini(&msg->identifier);
  // data
  ml_classifiers__msg__ClassDataPoint__Sequence__fini(&msg->data);
}

ml_classifiers__srv__ClassifyData_Request *
ml_classifiers__srv__ClassifyData_Request__create()
{
  ml_classifiers__srv__ClassifyData_Request * msg = (ml_classifiers__srv__ClassifyData_Request *)malloc(sizeof(ml_classifiers__srv__ClassifyData_Request));
  if (!msg) {
    return NULL;
  }
  memset(msg, 0, sizeof(ml_classifiers__srv__ClassifyData_Request));
  bool success = ml_classifiers__srv__ClassifyData_Request__init(msg);
  if (!success) {
    free(msg);
    return NULL;
  }
  return msg;
}

void
ml_classifiers__srv__ClassifyData_Request__destroy(ml_classifiers__srv__ClassifyData_Request * msg)
{
  if (msg) {
    ml_classifiers__srv__ClassifyData_Request__fini(msg);
  }
  free(msg);
}


bool
ml_classifiers__srv__ClassifyData_Request__Sequence__init(ml_classifiers__srv__ClassifyData_Request__Sequence * array, size_t size)
{
  if (!array) {
    return false;
  }
  ml_classifiers__srv__ClassifyData_Request * data = NULL;
  if (size) {
    data = (ml_classifiers__srv__ClassifyData_Request *)calloc(size, sizeof(ml_classifiers__srv__ClassifyData_Request));
    if (!data) {
      return false;
    }
    // initialize all array elements
    size_t i;
    for (i = 0; i < size; ++i) {
      bool success = ml_classifiers__srv__ClassifyData_Request__init(&data[i]);
      if (!success) {
        break;
      }
    }
    if (i < size) {
      // if initialization failed finalize the already initialized array elements
      for (; i > 0; --i) {
        ml_classifiers__srv__ClassifyData_Request__fini(&data[i - 1]);
      }
      free(data);
      return false;
    }
  }
  array->data = data;
  array->size = size;
  array->capacity = size;
  return true;
}

void
ml_classifiers__srv__ClassifyData_Request__Sequence__fini(ml_classifiers__srv__ClassifyData_Request__Sequence * array)
{
  if (!array) {
    return;
  }
  if (array->data) {
    // ensure that data and capacity values are consistent
    assert(array->capacity > 0);
    // finalize all array elements
    for (size_t i = 0; i < array->capacity; ++i) {
      ml_classifiers__srv__ClassifyData_Request__fini(&array->data[i]);
    }
    free(array->data);
    array->data = NULL;
    array->size = 0;
    array->capacity = 0;
  } else {
    // ensure that data, size, and capacity values are consistent
    assert(0 == array->size);
    assert(0 == array->capacity);
  }
}

ml_classifiers__srv__ClassifyData_Request__Sequence *
ml_classifiers__srv__ClassifyData_Request__Sequence__create(size_t size)
{
  ml_classifiers__srv__ClassifyData_Request__Sequence * array = (ml_classifiers__srv__ClassifyData_Request__Sequence *)malloc(sizeof(ml_classifiers__srv__ClassifyData_Request__Sequence));
  if (!array) {
    return NULL;
  }
  bool success = ml_classifiers__srv__ClassifyData_Request__Sequence__init(array, size);
  if (!success) {
    free(array);
    return NULL;
  }
  return array;
}

void
ml_classifiers__srv__ClassifyData_Request__Sequence__destroy(ml_classifiers__srv__ClassifyData_Request__Sequence * array)
{
  if (array) {
    ml_classifiers__srv__ClassifyData_Request__Sequence__fini(array);
  }
  free(array);
}


// Include directives for member types
// Member `classifications`
// already included above
// #include "rosidl_generator_c/string_functions.h"

bool
ml_classifiers__srv__ClassifyData_Response__init(ml_classifiers__srv__ClassifyData_Response * msg)
{
  if (!msg) {
    return false;
  }
  // classifications
  if (!rosidl_generator_c__String__Sequence__init(&msg->classifications, 0)) {
    ml_classifiers__srv__ClassifyData_Response__destroy(msg);
    return false;
  }
  return true;
}

void
ml_classifiers__srv__ClassifyData_Response__fini(ml_classifiers__srv__ClassifyData_Response * msg)
{
  if (!msg) {
    return;
  }
  // classifications
  rosidl_generator_c__String__Sequence__fini(&msg->classifications);
}

ml_classifiers__srv__ClassifyData_Response *
ml_classifiers__srv__ClassifyData_Response__create()
{
  ml_classifiers__srv__ClassifyData_Response * msg = (ml_classifiers__srv__ClassifyData_Response *)malloc(sizeof(ml_classifiers__srv__ClassifyData_Response));
  if (!msg) {
    return NULL;
  }
  memset(msg, 0, sizeof(ml_classifiers__srv__ClassifyData_Response));
  bool success = ml_classifiers__srv__ClassifyData_Response__init(msg);
  if (!success) {
    free(msg);
    return NULL;
  }
  return msg;
}

void
ml_classifiers__srv__ClassifyData_Response__destroy(ml_classifiers__srv__ClassifyData_Response * msg)
{
  if (msg) {
    ml_classifiers__srv__ClassifyData_Response__fini(msg);
  }
  free(msg);
}


bool
ml_classifiers__srv__ClassifyData_Response__Sequence__init(ml_classifiers__srv__ClassifyData_Response__Sequence * array, size_t size)
{
  if (!array) {
    return false;
  }
  ml_classifiers__srv__ClassifyData_Response * data = NULL;
  if (size) {
    data = (ml_classifiers__srv__ClassifyData_Response *)calloc(size, sizeof(ml_classifiers__srv__ClassifyData_Response));
    if (!data) {
      return false;
    }
    // initialize all array elements
    size_t i;
    for (i = 0; i < size; ++i) {
      bool success = ml_classifiers__srv__ClassifyData_Response__init(&data[i]);
      if (!success) {
        break;
      }
    }
    if (i < size) {
      // if initialization failed finalize the already initialized array elements
      for (; i > 0; --i) {
        ml_classifiers__srv__ClassifyData_Response__fini(&data[i - 1]);
      }
      free(data);
      return false;
    }
  }
  array->data = data;
  array->size = size;
  array->capacity = size;
  return true;
}

void
ml_classifiers__srv__ClassifyData_Response__Sequence__fini(ml_classifiers__srv__ClassifyData_Response__Sequence * array)
{
  if (!array) {
    return;
  }
  if (array->data) {
    // ensure that data and capacity values are consistent
    assert(array->capacity > 0);
    // finalize all array elements
    for (size_t i = 0; i < array->capacity; ++i) {
      ml_classifiers__srv__ClassifyData_Response__fini(&array->data[i]);
    }
    free(array->data);
    array->data = NULL;
    array->size = 0;
    array->capacity = 0;
  } else {
    // ensure that data, size, and capacity values are consistent
    assert(0 == array->size);
    assert(0 == array->capacity);
  }
}

ml_classifiers__srv__ClassifyData_Response__Sequence *
ml_classifiers__srv__ClassifyData_Response__Sequence__create(size_t size)
{
  ml_classifiers__srv__ClassifyData_Response__Sequence * array = (ml_classifiers__srv__ClassifyData_Response__Sequence *)malloc(sizeof(ml_classifiers__srv__ClassifyData_Response__Sequence));
  if (!array) {
    return NULL;
  }
  bool success = ml_classifiers__srv__ClassifyData_Response__Sequence__init(array, size);
  if (!success) {
    free(array);
    return NULL;
  }
  return array;
}

void
ml_classifiers__srv__ClassifyData_Response__Sequence__destroy(ml_classifiers__srv__ClassifyData_Response__Sequence * array)
{
  if (array) {
    ml_classifiers__srv__ClassifyData_Response__Sequence__fini(array);
  }
  free(array);
}
