// generated from rosidl_generator_cpp/resource/idl__struct.hpp.em
// with input from ml_classifiers:srv/ClassifyData.idl
// generated code does not contain a copyright notice

#ifndef ML_CLASSIFIERS__SRV__CLASSIFY_DATA__STRUCT_HPP_
#define ML_CLASSIFIERS__SRV__CLASSIFY_DATA__STRUCT_HPP_

#include <rosidl_generator_cpp/bounded_vector.hpp>
#include <rosidl_generator_cpp/message_initialization.hpp>
#include <algorithm>
#include <array>
#include <memory>
#include <string>
#include <vector>

// Protect against ERROR being predefined on Windows, in case somebody defines a
// constant by that name.
#if defined(_WIN32)
  #if defined(ERROR)
    #undef ERROR
  #endif
  #if defined(NO_ERROR)
    #undef NO_ERROR
  #endif
#endif

// Include directives for member types
// Member 'data'
#include "ml_classifiers/msg/class_data_point__struct.hpp"

#ifndef _WIN32
# define DEPRECATED__ml_classifiers__srv__ClassifyData_Request __attribute__((deprecated))
#else
# define DEPRECATED__ml_classifiers__srv__ClassifyData_Request __declspec(deprecated)
#endif

namespace ml_classifiers
{

namespace srv
{

// message struct
template<class ContainerAllocator>
struct ClassifyData_Request_
{
  using Type = ClassifyData_Request_<ContainerAllocator>;

  explicit ClassifyData_Request_(rosidl_generator_cpp::MessageInitialization _init = rosidl_generator_cpp::MessageInitialization::ALL)
  {
    if (rosidl_generator_cpp::MessageInitialization::ALL == _init ||
      rosidl_generator_cpp::MessageInitialization::ZERO == _init)
    {
      this->identifier = "";
    }
  }

  explicit ClassifyData_Request_(const ContainerAllocator & _alloc, rosidl_generator_cpp::MessageInitialization _init = rosidl_generator_cpp::MessageInitialization::ALL)
  : identifier(_alloc)
  {
    if (rosidl_generator_cpp::MessageInitialization::ALL == _init ||
      rosidl_generator_cpp::MessageInitialization::ZERO == _init)
    {
      this->identifier = "";
    }
  }

  // field types and members
  using _identifier_type =
    std::basic_string<char, std::char_traits<char>, typename ContainerAllocator::template rebind<char>::other>;
  _identifier_type identifier;
  using _data_type =
    std::vector<ml_classifiers::msg::ClassDataPoint_<ContainerAllocator>, typename ContainerAllocator::template rebind<ml_classifiers::msg::ClassDataPoint_<ContainerAllocator>>::other>;
  _data_type data;

  // setters for named parameter idiom
  Type & set__identifier(
    const std::basic_string<char, std::char_traits<char>, typename ContainerAllocator::template rebind<char>::other> & _arg)
  {
    this->identifier = _arg;
    return *this;
  }
  Type & set__data(
    const std::vector<ml_classifiers::msg::ClassDataPoint_<ContainerAllocator>, typename ContainerAllocator::template rebind<ml_classifiers::msg::ClassDataPoint_<ContainerAllocator>>::other> & _arg)
  {
    this->data = _arg;
    return *this;
  }

  // constant declarations

  // pointer types
  using RawPtr =
    ml_classifiers::srv::ClassifyData_Request_<ContainerAllocator> *;
  using ConstRawPtr =
    const ml_classifiers::srv::ClassifyData_Request_<ContainerAllocator> *;
  using SharedPtr =
    std::shared_ptr<ml_classifiers::srv::ClassifyData_Request_<ContainerAllocator>>;
  using ConstSharedPtr =
    std::shared_ptr<ml_classifiers::srv::ClassifyData_Request_<ContainerAllocator> const>;

  template<typename Deleter = std::default_delete<
      ml_classifiers::srv::ClassifyData_Request_<ContainerAllocator>>>
  using UniquePtrWithDeleter =
    std::unique_ptr<ml_classifiers::srv::ClassifyData_Request_<ContainerAllocator>, Deleter>;

  using UniquePtr = UniquePtrWithDeleter<>;

  template<typename Deleter = std::default_delete<
      ml_classifiers::srv::ClassifyData_Request_<ContainerAllocator>>>
  using ConstUniquePtrWithDeleter =
    std::unique_ptr<ml_classifiers::srv::ClassifyData_Request_<ContainerAllocator> const, Deleter>;
  using ConstUniquePtr = ConstUniquePtrWithDeleter<>;

  using WeakPtr =
    std::weak_ptr<ml_classifiers::srv::ClassifyData_Request_<ContainerAllocator>>;
  using ConstWeakPtr =
    std::weak_ptr<ml_classifiers::srv::ClassifyData_Request_<ContainerAllocator> const>;

  // pointer types similar to ROS 1, use SharedPtr / ConstSharedPtr instead
  // NOTE: Can't use 'using' here because GNU C++ can't parse attributes properly
  typedef DEPRECATED__ml_classifiers__srv__ClassifyData_Request
    std::shared_ptr<ml_classifiers::srv::ClassifyData_Request_<ContainerAllocator>>
    Ptr;
  typedef DEPRECATED__ml_classifiers__srv__ClassifyData_Request
    std::shared_ptr<ml_classifiers::srv::ClassifyData_Request_<ContainerAllocator> const>
    ConstPtr;

  // comparison operators
  bool operator==(const ClassifyData_Request_ & other) const
  {
    if (this->identifier != other.identifier) {
      return false;
    }
    if (this->data != other.data) {
      return false;
    }
    return true;
  }
  bool operator!=(const ClassifyData_Request_ & other) const
  {
    return !this->operator==(other);
  }
};  // struct ClassifyData_Request_

// alias to use template instance with default allocator
using ClassifyData_Request =
  ml_classifiers::srv::ClassifyData_Request_<std::allocator<void>>;

// constant definitions

}  // namespace srv

}  // namespace ml_classifiers

// Protect against ERROR being predefined on Windows, in case somebody defines a
// constant by that name.
#if defined(_WIN32)
  #if defined(ERROR)
    #undef ERROR
  #endif
  #if defined(NO_ERROR)
    #undef NO_ERROR
  #endif
#endif

#ifndef _WIN32
# define DEPRECATED__ml_classifiers__srv__ClassifyData_Response __attribute__((deprecated))
#else
# define DEPRECATED__ml_classifiers__srv__ClassifyData_Response __declspec(deprecated)
#endif

namespace ml_classifiers
{

namespace srv
{

// message struct
template<class ContainerAllocator>
struct ClassifyData_Response_
{
  using Type = ClassifyData_Response_<ContainerAllocator>;

  explicit ClassifyData_Response_(rosidl_generator_cpp::MessageInitialization _init = rosidl_generator_cpp::MessageInitialization::ALL)
  {
    (void)_init;
  }

  explicit ClassifyData_Response_(const ContainerAllocator & _alloc, rosidl_generator_cpp::MessageInitialization _init = rosidl_generator_cpp::MessageInitialization::ALL)
  {
    (void)_init;
    (void)_alloc;
  }

  // field types and members
  using _classifications_type =
    std::vector<std::basic_string<char, std::char_traits<char>, typename ContainerAllocator::template rebind<char>::other>, typename ContainerAllocator::template rebind<std::basic_string<char, std::char_traits<char>, typename ContainerAllocator::template rebind<char>::other>>::other>;
  _classifications_type classifications;

  // setters for named parameter idiom
  Type & set__classifications(
    const std::vector<std::basic_string<char, std::char_traits<char>, typename ContainerAllocator::template rebind<char>::other>, typename ContainerAllocator::template rebind<std::basic_string<char, std::char_traits<char>, typename ContainerAllocator::template rebind<char>::other>>::other> & _arg)
  {
    this->classifications = _arg;
    return *this;
  }

  // constant declarations

  // pointer types
  using RawPtr =
    ml_classifiers::srv::ClassifyData_Response_<ContainerAllocator> *;
  using ConstRawPtr =
    const ml_classifiers::srv::ClassifyData_Response_<ContainerAllocator> *;
  using SharedPtr =
    std::shared_ptr<ml_classifiers::srv::ClassifyData_Response_<ContainerAllocator>>;
  using ConstSharedPtr =
    std::shared_ptr<ml_classifiers::srv::ClassifyData_Response_<ContainerAllocator> const>;

  template<typename Deleter = std::default_delete<
      ml_classifiers::srv::ClassifyData_Response_<ContainerAllocator>>>
  using UniquePtrWithDeleter =
    std::unique_ptr<ml_classifiers::srv::ClassifyData_Response_<ContainerAllocator>, Deleter>;

  using UniquePtr = UniquePtrWithDeleter<>;

  template<typename Deleter = std::default_delete<
      ml_classifiers::srv::ClassifyData_Response_<ContainerAllocator>>>
  using ConstUniquePtrWithDeleter =
    std::unique_ptr<ml_classifiers::srv::ClassifyData_Response_<ContainerAllocator> const, Deleter>;
  using ConstUniquePtr = ConstUniquePtrWithDeleter<>;

  using WeakPtr =
    std::weak_ptr<ml_classifiers::srv::ClassifyData_Response_<ContainerAllocator>>;
  using ConstWeakPtr =
    std::weak_ptr<ml_classifiers::srv::ClassifyData_Response_<ContainerAllocator> const>;

  // pointer types similar to ROS 1, use SharedPtr / ConstSharedPtr instead
  // NOTE: Can't use 'using' here because GNU C++ can't parse attributes properly
  typedef DEPRECATED__ml_classifiers__srv__ClassifyData_Response
    std::shared_ptr<ml_classifiers::srv::ClassifyData_Response_<ContainerAllocator>>
    Ptr;
  typedef DEPRECATED__ml_classifiers__srv__ClassifyData_Response
    std::shared_ptr<ml_classifiers::srv::ClassifyData_Response_<ContainerAllocator> const>
    ConstPtr;

  // comparison operators
  bool operator==(const ClassifyData_Response_ & other) const
  {
    if (this->classifications != other.classifications) {
      return false;
    }
    return true;
  }
  bool operator!=(const ClassifyData_Response_ & other) const
  {
    return !this->operator==(other);
  }
};  // struct ClassifyData_Response_

// alias to use template instance with default allocator
using ClassifyData_Response =
  ml_classifiers::srv::ClassifyData_Response_<std::allocator<void>>;

// constant definitions

}  // namespace srv

}  // namespace ml_classifiers

namespace ml_classifiers
{

namespace srv
{

struct ClassifyData
{
  using Request = ml_classifiers::srv::ClassifyData_Request;
  using Response = ml_classifiers::srv::ClassifyData_Response;
};

}  // namespace srv

}  // namespace ml_classifiers

#endif  // ML_CLASSIFIERS__SRV__CLASSIFY_DATA__STRUCT_HPP_
