// generated from rosidl_typesupport_introspection_cpp/resource/idl__type_support.cpp.em
// with input from ml_classifiers:srv/ClassifyData.idl
// generated code does not contain a copyright notice

#include "array"
#include "cstddef"
#include "string"
#include "vector"
#include "rosidl_generator_c/message_type_support_struct.h"
#include "rosidl_typesupport_cpp/message_type_support.hpp"
#include "rosidl_typesupport_interface/macros.h"
#include "ml_classifiers/srv/classify_data__struct.hpp"
#include "rosidl_typesupport_introspection_cpp/field_types.hpp"
#include "rosidl_typesupport_introspection_cpp/identifier.hpp"
#include "rosidl_typesupport_introspection_cpp/message_introspection.hpp"
#include "rosidl_typesupport_introspection_cpp/message_type_support_decl.hpp"
#include "rosidl_typesupport_introspection_cpp/visibility_control.h"

namespace ml_classifiers
{

namespace srv
{

namespace rosidl_typesupport_introspection_cpp
{

size_t size_function__ClassifyData_Request__data(const void * untyped_member)
{
  const auto * member = reinterpret_cast<const std::vector<ml_classifiers::msg::ClassDataPoint> *>(untyped_member);
  return member->size();
}

const void * get_const_function__ClassifyData_Request__data(const void * untyped_member, size_t index)
{
  const auto & member =
    *reinterpret_cast<const std::vector<ml_classifiers::msg::ClassDataPoint> *>(untyped_member);
  return &member[index];
}

void * get_function__ClassifyData_Request__data(void * untyped_member, size_t index)
{
  auto & member =
    *reinterpret_cast<std::vector<ml_classifiers::msg::ClassDataPoint> *>(untyped_member);
  return &member[index];
}

void resize_function__ClassifyData_Request__data(void * untyped_member, size_t size)
{
  auto * member =
    reinterpret_cast<std::vector<ml_classifiers::msg::ClassDataPoint> *>(untyped_member);
  member->resize(size);
}

static const ::rosidl_typesupport_introspection_cpp::MessageMember ClassifyData_Request_message_member_array[2] = {
  {
    "identifier",  // name
    ::rosidl_typesupport_introspection_cpp::ROS_TYPE_STRING,  // type
    0,  // upper bound of string
    NULL,  // members of sub message
    false,  // is array
    0,  // array size
    false,  // is upper bound
    offsetof(ml_classifiers::srv::ClassifyData_Request, identifier),  // bytes offset in struct
    nullptr,  // default value
    nullptr,  // size() function pointer
    nullptr,  // get_const(index) function pointer
    nullptr,  // get(index) function pointer
    NULL  // resize(index) function pointer
  },
  {
    "data",  // name
    ::rosidl_typesupport_introspection_cpp::ROS_TYPE_MESSAGE,  // type
    0,  // upper bound of string
    ::rosidl_typesupport_introspection_cpp::get_message_type_support_handle<ml_classifiers::msg::ClassDataPoint>(),  // members of sub message
    true,  // is array
    0,  // array size
    false,  // is upper bound
    offsetof(ml_classifiers::srv::ClassifyData_Request, data),  // bytes offset in struct
    nullptr,  // default value
    size_function__ClassifyData_Request__data,  // size() function pointer
    get_const_function__ClassifyData_Request__data,  // get_const(index) function pointer
    get_function__ClassifyData_Request__data,  // get(index) function pointer
    resize_function__ClassifyData_Request__data  // resize(index) function pointer
  }
};

static const ::rosidl_typesupport_introspection_cpp::MessageMembers ClassifyData_Request_message_members = {
  "ml_classifiers::srv",  // message namespace
  "ClassifyData_Request",  // message name
  2,  // number of fields
  sizeof(ml_classifiers::srv::ClassifyData_Request),
  ClassifyData_Request_message_member_array  // message members
};

static const rosidl_message_type_support_t ClassifyData_Request_message_type_support_handle = {
  ::rosidl_typesupport_introspection_cpp::typesupport_identifier,
  &ClassifyData_Request_message_members,
  get_message_typesupport_handle_function,
};

}  // namespace rosidl_typesupport_introspection_cpp

}  // namespace srv

}  // namespace ml_classifiers


namespace rosidl_typesupport_introspection_cpp
{

template<>
ROSIDL_TYPESUPPORT_INTROSPECTION_CPP_PUBLIC
const rosidl_message_type_support_t *
get_message_type_support_handle<ml_classifiers::srv::ClassifyData_Request>()
{
  return &::ml_classifiers::srv::rosidl_typesupport_introspection_cpp::ClassifyData_Request_message_type_support_handle;
}

}  // namespace rosidl_typesupport_introspection_cpp

#ifdef __cplusplus
extern "C"
{
#endif

ROSIDL_TYPESUPPORT_INTROSPECTION_CPP_PUBLIC
const rosidl_message_type_support_t *
ROSIDL_TYPESUPPORT_INTERFACE__MESSAGE_SYMBOL_NAME(rosidl_typesupport_introspection_cpp, ml_classifiers, srv, ClassifyData_Request)() {
  return &::ml_classifiers::srv::rosidl_typesupport_introspection_cpp::ClassifyData_Request_message_type_support_handle;
}

#ifdef __cplusplus
}
#endif

// already included above
// #include "array"
// already included above
// #include "cstddef"
// already included above
// #include "string"
// already included above
// #include "vector"
// already included above
// #include "rosidl_generator_c/message_type_support_struct.h"
// already included above
// #include "rosidl_typesupport_cpp/message_type_support.hpp"
// already included above
// #include "rosidl_typesupport_interface/macros.h"
// already included above
// #include "ml_classifiers/srv/classify_data__struct.hpp"
// already included above
// #include "rosidl_typesupport_introspection_cpp/field_types.hpp"
// already included above
// #include "rosidl_typesupport_introspection_cpp/identifier.hpp"
// already included above
// #include "rosidl_typesupport_introspection_cpp/message_introspection.hpp"
// already included above
// #include "rosidl_typesupport_introspection_cpp/message_type_support_decl.hpp"
// already included above
// #include "rosidl_typesupport_introspection_cpp/visibility_control.h"

namespace ml_classifiers
{

namespace srv
{

namespace rosidl_typesupport_introspection_cpp
{

size_t size_function__ClassifyData_Response__classifications(const void * untyped_member)
{
  const auto * member = reinterpret_cast<const std::vector<std::string> *>(untyped_member);
  return member->size();
}

const void * get_const_function__ClassifyData_Response__classifications(const void * untyped_member, size_t index)
{
  const auto & member =
    *reinterpret_cast<const std::vector<std::string> *>(untyped_member);
  return &member[index];
}

void * get_function__ClassifyData_Response__classifications(void * untyped_member, size_t index)
{
  auto & member =
    *reinterpret_cast<std::vector<std::string> *>(untyped_member);
  return &member[index];
}

void resize_function__ClassifyData_Response__classifications(void * untyped_member, size_t size)
{
  auto * member =
    reinterpret_cast<std::vector<std::string> *>(untyped_member);
  member->resize(size);
}

static const ::rosidl_typesupport_introspection_cpp::MessageMember ClassifyData_Response_message_member_array[1] = {
  {
    "classifications",  // name
    ::rosidl_typesupport_introspection_cpp::ROS_TYPE_STRING,  // type
    0,  // upper bound of string
    NULL,  // members of sub message
    true,  // is array
    0,  // array size
    false,  // is upper bound
    offsetof(ml_classifiers::srv::ClassifyData_Response, classifications),  // bytes offset in struct
    nullptr,  // default value
    size_function__ClassifyData_Response__classifications,  // size() function pointer
    get_const_function__ClassifyData_Response__classifications,  // get_const(index) function pointer
    get_function__ClassifyData_Response__classifications,  // get(index) function pointer
    resize_function__ClassifyData_Response__classifications  // resize(index) function pointer
  }
};

static const ::rosidl_typesupport_introspection_cpp::MessageMembers ClassifyData_Response_message_members = {
  "ml_classifiers::srv",  // message namespace
  "ClassifyData_Response",  // message name
  1,  // number of fields
  sizeof(ml_classifiers::srv::ClassifyData_Response),
  ClassifyData_Response_message_member_array  // message members
};

static const rosidl_message_type_support_t ClassifyData_Response_message_type_support_handle = {
  ::rosidl_typesupport_introspection_cpp::typesupport_identifier,
  &ClassifyData_Response_message_members,
  get_message_typesupport_handle_function,
};

}  // namespace rosidl_typesupport_introspection_cpp

}  // namespace srv

}  // namespace ml_classifiers


namespace rosidl_typesupport_introspection_cpp
{

template<>
ROSIDL_TYPESUPPORT_INTROSPECTION_CPP_PUBLIC
const rosidl_message_type_support_t *
get_message_type_support_handle<ml_classifiers::srv::ClassifyData_Response>()
{
  return &::ml_classifiers::srv::rosidl_typesupport_introspection_cpp::ClassifyData_Response_message_type_support_handle;
}

}  // namespace rosidl_typesupport_introspection_cpp

#ifdef __cplusplus
extern "C"
{
#endif

ROSIDL_TYPESUPPORT_INTROSPECTION_CPP_PUBLIC
const rosidl_message_type_support_t *
ROSIDL_TYPESUPPORT_INTERFACE__MESSAGE_SYMBOL_NAME(rosidl_typesupport_introspection_cpp, ml_classifiers, srv, ClassifyData_Response)() {
  return &::ml_classifiers::srv::rosidl_typesupport_introspection_cpp::ClassifyData_Response_message_type_support_handle;
}

#ifdef __cplusplus
}
#endif

#include "rosidl_generator_c/service_type_support_struct.h"
// already included above
// #include "rosidl_typesupport_cpp/message_type_support.hpp"
#include "rosidl_typesupport_cpp/service_type_support.hpp"
// already included above
// #include "rosidl_typesupport_interface/macros.h"
// already included above
// #include "rosidl_typesupport_introspection_cpp/visibility_control.h"
// already included above
// #include "ml_classifiers/srv/classify_data__struct.hpp"
// already included above
// #include "rosidl_typesupport_introspection_cpp/identifier.hpp"
// already included above
// #include "rosidl_typesupport_introspection_cpp/message_type_support_decl.hpp"
#include "rosidl_typesupport_introspection_cpp/service_introspection.hpp"
#include "rosidl_typesupport_introspection_cpp/service_type_support_decl.hpp"

namespace ml_classifiers
{

namespace srv
{

namespace rosidl_typesupport_introspection_cpp
{

// this is intentionally not const to allow initialization later to prevent an initialization race
static ::rosidl_typesupport_introspection_cpp::ServiceMembers ClassifyData_service_members = {
  "ml_classifiers::srv",  // service namespace
  "ClassifyData",  // service name
  // these two fields are initialized below on the first access
  // see get_service_type_support_handle<ml_classifiers::srv::ClassifyData>()
  nullptr,  // request message
  nullptr  // response message
};

static const rosidl_service_type_support_t ClassifyData_service_type_support_handle = {
  ::rosidl_typesupport_introspection_cpp::typesupport_identifier,
  &ClassifyData_service_members,
  get_service_typesupport_handle_function,
};

}  // namespace rosidl_typesupport_introspection_cpp

}  // namespace srv

}  // namespace ml_classifiers


namespace rosidl_typesupport_introspection_cpp
{

template<>
ROSIDL_TYPESUPPORT_INTROSPECTION_CPP_PUBLIC
const rosidl_service_type_support_t *
get_service_type_support_handle<ml_classifiers::srv::ClassifyData>()
{
  // get a handle to the value to be returned
  auto service_type_support =
    &::ml_classifiers::srv::rosidl_typesupport_introspection_cpp::ClassifyData_service_type_support_handle;
  // get a non-const and properly typed version of the data void *
  auto service_members = const_cast<::rosidl_typesupport_introspection_cpp::ServiceMembers *>(
    static_cast<const ::rosidl_typesupport_introspection_cpp::ServiceMembers *>(
      service_type_support->data));
  // make sure that both the request_members_ and the response_members_ are initialized
  // if they are not, initialize them
  if (
    service_members->request_members_ == nullptr ||
    service_members->response_members_ == nullptr)
  {
    // initialize the request_members_ with the static function from the external library
    service_members->request_members_ = static_cast<
      const ::rosidl_typesupport_introspection_cpp::MessageMembers *
      >(
      ::rosidl_typesupport_introspection_cpp::get_message_type_support_handle<
        ::ml_classifiers::srv::ClassifyData_Request
      >()->data
      );
    // initialize the response_members_ with the static function from the external library
    service_members->response_members_ = static_cast<
      const ::rosidl_typesupport_introspection_cpp::MessageMembers *
      >(
      ::rosidl_typesupport_introspection_cpp::get_message_type_support_handle<
        ::ml_classifiers::srv::ClassifyData_Response
      >()->data
      );
  }
  // finally return the properly initialized service_type_support handle
  return service_type_support;
}

}  // namespace rosidl_typesupport_introspection_cpp

#ifdef __cplusplus
extern "C"
{
#endif

ROSIDL_TYPESUPPORT_INTROSPECTION_CPP_PUBLIC
const rosidl_service_type_support_t *
ROSIDL_TYPESUPPORT_INTERFACE__SERVICE_SYMBOL_NAME(rosidl_typesupport_introspection_cpp, ml_classifiers, srv, ClassifyData)() {
  return ::rosidl_typesupport_introspection_cpp::get_service_type_support_handle<ml_classifiers::srv::ClassifyData>();
}

#ifdef __cplusplus
}
#endif
