#ifndef _H_03EC31E92317F01279C4A28C52C81918_AddClassData__H_
#define _H_03EC31E92317F01279C4A28C52C81918_AddClassData__H_

#include "sacpp_mapping.h"
#include "cpp_dcps_if.h"
#include "ml_classifiers/msg/dds_opensplice/ClassDataPoint_.h"


namespace ml_classifiers
{
    namespace srv
    {
        namespace dds_
        {
            struct  AddClassData_Request_
            {
                struct _data__seq_uniq_{};
                typedef DDS_DCPSUVLSeq< ::ml_classifiers::msg::dds_::ClassDataPoint_, struct _data__seq_uniq_ > _data__seq;
                typedef DDS_DCPSSequence_var< _data__seq > _data__seq_var;
                typedef DDS_DCPSSequence_out< _data__seq > _data__seq_out;
                ::DDS::String_mgr identifier_;
                _data__seq data_;
            };

            typedef DDS_DCPSStruct_var<AddClassData_Request_> AddClassData_Request__var;
            typedef DDS_DCPSStruct_out < AddClassData_Request_> AddClassData_Request__out;

            struct  AddClassData_Response_
            {
                ::DDS::Boolean success_;
            };

            typedef DDS_DCPSStruct_var<AddClassData_Response_> AddClassData_Response__var;
            typedef AddClassData_Response_& AddClassData_Response__out;

            struct  Sample_AddClassData_Request_
            {
                ::DDS::ULongLong client_guid_0_;
                ::DDS::ULongLong client_guid_1_;
                ::DDS::LongLong sequence_number_;
                ::ml_classifiers::srv::dds_::AddClassData_Request_ request_;
            };

            typedef DDS_DCPSStruct_var<Sample_AddClassData_Request_> Sample_AddClassData_Request__var;
            typedef DDS_DCPSStruct_out < Sample_AddClassData_Request_> Sample_AddClassData_Request__out;

            struct  Sample_AddClassData_Response_
            {
                ::DDS::ULongLong client_guid_0_;
                ::DDS::ULongLong client_guid_1_;
                ::DDS::LongLong sequence_number_;
                ::ml_classifiers::srv::dds_::AddClassData_Response_ response_;
            };

            typedef DDS_DCPSStruct_var<Sample_AddClassData_Response_> Sample_AddClassData_Response__var;
            typedef Sample_AddClassData_Response_& Sample_AddClassData_Response__out;

        }

    }

}

#endif /* _H_03EC31E92317F01279C4A28C52C81918_AddClassData__H_ */
