#ifndef _H_10FAE4357F80CB7FD9A6F58E1F5EA017_ClassifyData__H_
#define _H_10FAE4357F80CB7FD9A6F58E1F5EA017_ClassifyData__H_

#include "sacpp_mapping.h"
#include "cpp_dcps_if.h"
#include "ml_classifiers/msg/dds_opensplice/ClassDataPoint_.h"


namespace ml_classifiers
{
    namespace srv
    {
        namespace dds_
        {
            struct  ClassifyData_Request_
            {
                struct _data__seq_uniq_{};
                typedef DDS_DCPSUVLSeq< ::ml_classifiers::msg::dds_::ClassDataPoint_, struct _data__seq_uniq_ > _data__seq;
                typedef DDS_DCPSSequence_var< _data__seq > _data__seq_var;
                typedef DDS_DCPSSequence_out< _data__seq > _data__seq_out;
                ::DDS::String_mgr identifier_;
                _data__seq data_;
            };

            typedef DDS_DCPSStruct_var<ClassifyData_Request_> ClassifyData_Request__var;
            typedef DDS_DCPSStruct_out < ClassifyData_Request_> ClassifyData_Request__out;

            struct  ClassifyData_Response_
            {
                struct _classifications__seq_uniq_{};
                typedef DDS_DCPSUStrSeqT< struct _classifications__seq_uniq_ > _classifications__seq;
                typedef DDS_DCPSUStrSeq_var< _classifications__seq > _classifications__seq_var;
                typedef DDS_DCPSUStrSeq_out< _classifications__seq > _classifications__seq_out;
                _classifications__seq classifications_;
            };

            typedef DDS_DCPSStruct_var<ClassifyData_Response_> ClassifyData_Response__var;
            typedef DDS_DCPSStruct_out < ClassifyData_Response_> ClassifyData_Response__out;

            struct  Sample_ClassifyData_Request_
            {
                ::DDS::ULongLong client_guid_0_;
                ::DDS::ULongLong client_guid_1_;
                ::DDS::LongLong sequence_number_;
                ::ml_classifiers::srv::dds_::ClassifyData_Request_ request_;
            };

            typedef DDS_DCPSStruct_var<Sample_ClassifyData_Request_> Sample_ClassifyData_Request__var;
            typedef DDS_DCPSStruct_out < Sample_ClassifyData_Request_> Sample_ClassifyData_Request__out;

            struct  Sample_ClassifyData_Response_
            {
                ::DDS::ULongLong client_guid_0_;
                ::DDS::ULongLong client_guid_1_;
                ::DDS::LongLong sequence_number_;
                ::ml_classifiers::srv::dds_::ClassifyData_Response_ response_;
            };

            typedef DDS_DCPSStruct_var<Sample_ClassifyData_Response_> Sample_ClassifyData_Response__var;
            typedef DDS_DCPSStruct_out < Sample_ClassifyData_Response_> Sample_ClassifyData_Response__out;

        }

    }

}

#endif /* _H_10FAE4357F80CB7FD9A6F58E1F5EA017_ClassifyData__H_ */
