#ifndef _H_C4C068EA39FA677356213B0EB8E1AA81_CreateClassifier__H_
#define _H_C4C068EA39FA677356213B0EB8E1AA81_CreateClassifier__H_

#include "sacpp_mapping.h"
#include "cpp_dcps_if.h"


namespace ml_classifiers
{
    namespace srv
    {
        namespace dds_
        {
            struct  CreateClassifier_Request_
            {
                ::DDS::String_mgr identifier_;
                ::DDS::String_mgr class_type_;
            };

            typedef DDS_DCPSStruct_var<CreateClassifier_Request_> CreateClassifier_Request__var;
            typedef DDS_DCPSStruct_out < CreateClassifier_Request_> CreateClassifier_Request__out;

            struct  CreateClassifier_Response_
            {
                ::DDS::Boolean success_;
            };

            typedef DDS_DCPSStruct_var<CreateClassifier_Response_> CreateClassifier_Response__var;
            typedef CreateClassifier_Response_& CreateClassifier_Response__out;

            struct  Sample_CreateClassifier_Request_
            {
                ::DDS::ULongLong client_guid_0_;
                ::DDS::ULongLong client_guid_1_;
                ::DDS::LongLong sequence_number_;
                ::ml_classifiers::srv::dds_::CreateClassifier_Request_ request_;
            };

            typedef DDS_DCPSStruct_var<Sample_CreateClassifier_Request_> Sample_CreateClassifier_Request__var;
            typedef DDS_DCPSStruct_out < Sample_CreateClassifier_Request_> Sample_CreateClassifier_Request__out;

            struct  Sample_CreateClassifier_Response_
            {
                ::DDS::ULongLong client_guid_0_;
                ::DDS::ULongLong client_guid_1_;
                ::DDS::LongLong sequence_number_;
                ::ml_classifiers::srv::dds_::CreateClassifier_Response_ response_;
            };

            typedef DDS_DCPSStruct_var<Sample_CreateClassifier_Response_> Sample_CreateClassifier_Response__var;
            typedef Sample_CreateClassifier_Response_& Sample_CreateClassifier_Response__out;

        }

    }

}

#endif /* _H_C4C068EA39FA677356213B0EB8E1AA81_CreateClassifier__H_ */
