// generated from rosidl_generator_c/resource/idl__functions.c.em
// with input from ml_classifiers:msg/ClassDataPoint.idl
// generated code does not contain a copyright notice
#include "ml_classifiers/msg/class_data_point__functions.h"

#include <assert.h>
#include <stdbool.h>
#include <stdlib.h>
#include <string.h>


// Include directives for member types
// Member `target_class`
#include "rosidl_generator_c/string_functions.h"
// Member `point`
#include "rosidl_generator_c/primitives_sequence_functions.h"

bool
ml_classifiers__msg__ClassDataPoint__init(ml_classifiers__msg__ClassDataPoint * msg)
{
  if (!msg) {
    return false;
  }
  // target_class
  if (!rosidl_generator_c__String__init(&msg->target_class)) {
    ml_classifiers__msg__ClassDataPoint__destroy(msg);
    return false;
  }
  // point
  if (!rosidl_generator_c__double__Sequence__init(&msg->point, 0)) {
    ml_classifiers__msg__ClassDataPoint__destroy(msg);
    return false;
  }
  return true;
}

void
ml_classifiers__msg__ClassDataPoint__fini(ml_classifiers__msg__ClassDataPoint * msg)
{
  if (!msg) {
    return;
  }
  // target_class
  rosidl_generator_c__String__fini(&msg->target_class);
  // point
  rosidl_generator_c__double__Sequence__fini(&msg->point);
}

ml_classifiers__msg__ClassDataPoint *
ml_classifiers__msg__ClassDataPoint__create()
{
  ml_classifiers__msg__ClassDataPoint * msg = (ml_classifiers__msg__ClassDataPoint *)malloc(sizeof(ml_classifiers__msg__ClassDataPoint));
  if (!msg) {
    return NULL;
  }
  memset(msg, 0, sizeof(ml_classifiers__msg__ClassDataPoint));
  bool success = ml_classifiers__msg__ClassDataPoint__init(msg);
  if (!success) {
    free(msg);
    return NULL;
  }
  return msg;
}

void
ml_classifiers__msg__ClassDataPoint__destroy(ml_classifiers__msg__ClassDataPoint * msg)
{
  if (msg) {
    ml_classifiers__msg__ClassDataPoint__fini(msg);
  }
  free(msg);
}


bool
ml_classifiers__msg__ClassDataPoint__Sequence__init(ml_classifiers__msg__ClassDataPoint__Sequence * array, size_t size)
{
  if (!array) {
    return false;
  }
  ml_classifiers__msg__ClassDataPoint * data = NULL;
  if (size) {
    data = (ml_classifiers__msg__ClassDataPoint *)calloc(size, sizeof(ml_classifiers__msg__ClassDataPoint));
    if (!data) {
      return false;
    }
    // initialize all array elements
    size_t i;
    for (i = 0; i < size; ++i) {
      bool success = ml_classifiers__msg__ClassDataPoint__init(&data[i]);
      if (!success) {
        break;
      }
    }
    if (i < size) {
      // if initialization failed finalize the already initialized array elements
      for (; i > 0; --i) {
        ml_classifiers__msg__ClassDataPoint__fini(&data[i - 1]);
      }
      free(data);
      return false;
    }
  }
  array->data = data;
  array->size = size;
  array->capacity = size;
  return true;
}

void
ml_classifiers__msg__ClassDataPoint__Sequence__fini(ml_classifiers__msg__ClassDataPoint__Sequence * array)
{
  if (!array) {
    return;
  }
  if (array->data) {
    // ensure that data and capacity values are consistent
    assert(array->capacity > 0);
    // finalize all array elements
    for (size_t i = 0; i < array->capacity; ++i) {
      ml_classifiers__msg__ClassDataPoint__fini(&array->data[i]);
    }
    free(array->data);
    array->data = NULL;
    array->size = 0;
    array->capacity = 0;
  } else {
    // ensure that data, size, and capacity values are consistent
    assert(0 == array->size);
    assert(0 == array->capacity);
  }
}

ml_classifiers__msg__ClassDataPoint__Sequence *
ml_classifiers__msg__ClassDataPoint__Sequence__create(size_t size)
{
  ml_classifiers__msg__ClassDataPoint__Sequence * array = (ml_classifiers__msg__ClassDataPoint__Sequence *)malloc(sizeof(ml_classifiers__msg__ClassDataPoint__Sequence));
  if (!array) {
    return NULL;
  }
  bool success = ml_classifiers__msg__ClassDataPoint__Sequence__init(array, size);
  if (!success) {
    free(array);
    return NULL;
  }
  return array;
}

void
ml_classifiers__msg__ClassDataPoint__Sequence__destroy(ml_classifiers__msg__ClassDataPoint__Sequence * array)
{
  if (array) {
    ml_classifiers__msg__ClassDataPoint__Sequence__fini(array);
  }
  free(array);
}
