// generated from rosidl_generator_cpp/resource/idl__struct.hpp.em
// with input from ml_classifiers:srv/ClearClassifier.idl
// generated code does not contain a copyright notice

#ifndef ML_CLASSIFIERS__SRV__CLEAR_CLASSIFIER__STRUCT_HPP_
#define ML_CLASSIFIERS__SRV__CLEAR_CLASSIFIER__STRUCT_HPP_

#include <rosidl_generator_cpp/bounded_vector.hpp>
#include <rosidl_generator_cpp/message_initialization.hpp>
#include <algorithm>
#include <array>
#include <memory>
#include <string>
#include <vector>

// Protect against ERROR being predefined on Windows, in case somebody defines a
// constant by that name.
#if defined(_WIN32)
  #if defined(ERROR)
    #undef ERROR
  #endif
  #if defined(NO_ERROR)
    #undef NO_ERROR
  #endif
#endif

#ifndef _WIN32
# define DEPRECATED__ml_classifiers__srv__ClearClassifier_Request __attribute__((deprecated))
#else
# define DEPRECATED__ml_classifiers__srv__ClearClassifier_Request __declspec(deprecated)
#endif

namespace ml_classifiers
{

namespace srv
{

// message struct
template<class ContainerAllocator>
struct ClearClassifier_Request_
{
  using Type = ClearClassifier_Request_<ContainerAllocator>;

  explicit ClearClassifier_Request_(rosidl_generator_cpp::MessageInitialization _init = rosidl_generator_cpp::MessageInitialization::ALL)
  {
    if (rosidl_generator_cpp::MessageInitialization::ALL == _init ||
      rosidl_generator_cpp::MessageInitialization::ZERO == _init)
    {
      this->identifier = "";
    }
  }

  explicit ClearClassifier_Request_(const ContainerAllocator & _alloc, rosidl_generator_cpp::MessageInitialization _init = rosidl_generator_cpp::MessageInitialization::ALL)
  : identifier(_alloc)
  {
    if (rosidl_generator_cpp::MessageInitialization::ALL == _init ||
      rosidl_generator_cpp::MessageInitialization::ZERO == _init)
    {
      this->identifier = "";
    }
  }

  // field types and members
  using _identifier_type =
    std::basic_string<char, std::char_traits<char>, typename ContainerAllocator::template rebind<char>::other>;
  _identifier_type identifier;

  // setters for named parameter idiom
  Type & set__identifier(
    const std::basic_string<char, std::char_traits<char>, typename ContainerAllocator::template rebind<char>::other> & _arg)
  {
    this->identifier = _arg;
    return *this;
  }

  // constant declarations

  // pointer types
  using RawPtr =
    ml_classifiers::srv::ClearClassifier_Request_<ContainerAllocator> *;
  using ConstRawPtr =
    const ml_classifiers::srv::ClearClassifier_Request_<ContainerAllocator> *;
  using SharedPtr =
    std::shared_ptr<ml_classifiers::srv::ClearClassifier_Request_<ContainerAllocator>>;
  using ConstSharedPtr =
    std::shared_ptr<ml_classifiers::srv::ClearClassifier_Request_<ContainerAllocator> const>;

  template<typename Deleter = std::default_delete<
      ml_classifiers::srv::ClearClassifier_Request_<ContainerAllocator>>>
  using UniquePtrWithDeleter =
    std::unique_ptr<ml_classifiers::srv::ClearClassifier_Request_<ContainerAllocator>, Deleter>;

  using UniquePtr = UniquePtrWithDeleter<>;

  template<typename Deleter = std::default_delete<
      ml_classifiers::srv::ClearClassifier_Request_<ContainerAllocator>>>
  using ConstUniquePtrWithDeleter =
    std::unique_ptr<ml_classifiers::srv::ClearClassifier_Request_<ContainerAllocator> const, Deleter>;
  using ConstUniquePtr = ConstUniquePtrWithDeleter<>;

  using WeakPtr =
    std::weak_ptr<ml_classifiers::srv::ClearClassifier_Request_<ContainerAllocator>>;
  using ConstWeakPtr =
    std::weak_ptr<ml_classifiers::srv::ClearClassifier_Request_<ContainerAllocator> const>;

  // pointer types similar to ROS 1, use SharedPtr / ConstSharedPtr instead
  // NOTE: Can't use 'using' here because GNU C++ can't parse attributes properly
  typedef DEPRECATED__ml_classifiers__srv__ClearClassifier_Request
    std::shared_ptr<ml_classifiers::srv::ClearClassifier_Request_<ContainerAllocator>>
    Ptr;
  typedef DEPRECATED__ml_classifiers__srv__ClearClassifier_Request
    std::shared_ptr<ml_classifiers::srv::ClearClassifier_Request_<ContainerAllocator> const>
    ConstPtr;

  // comparison operators
  bool operator==(const ClearClassifier_Request_ & other) const
  {
    if (this->identifier != other.identifier) {
      return false;
    }
    return true;
  }
  bool operator!=(const ClearClassifier_Request_ & other) const
  {
    return !this->operator==(other);
  }
};  // struct ClearClassifier_Request_

// alias to use template instance with default allocator
using ClearClassifier_Request =
  ml_classifiers::srv::ClearClassifier_Request_<std::allocator<void>>;

// constant definitions

}  // namespace srv

}  // namespace ml_classifiers

// Protect against ERROR being predefined on Windows, in case somebody defines a
// constant by that name.
#if defined(_WIN32)
  #if defined(ERROR)
    #undef ERROR
  #endif
  #if defined(NO_ERROR)
    #undef NO_ERROR
  #endif
#endif

#ifndef _WIN32
# define DEPRECATED__ml_classifiers__srv__ClearClassifier_Response __attribute__((deprecated))
#else
# define DEPRECATED__ml_classifiers__srv__ClearClassifier_Response __declspec(deprecated)
#endif

namespace ml_classifiers
{

namespace srv
{

// message struct
template<class ContainerAllocator>
struct ClearClassifier_Response_
{
  using Type = ClearClassifier_Response_<ContainerAllocator>;

  explicit ClearClassifier_Response_(rosidl_generator_cpp::MessageInitialization _init = rosidl_generator_cpp::MessageInitialization::ALL)
  {
    if (rosidl_generator_cpp::MessageInitialization::ALL == _init ||
      rosidl_generator_cpp::MessageInitialization::ZERO == _init)
    {
      this->success = false;
    }
  }

  explicit ClearClassifier_Response_(const ContainerAllocator & _alloc, rosidl_generator_cpp::MessageInitialization _init = rosidl_generator_cpp::MessageInitialization::ALL)
  {
    (void)_alloc;
    if (rosidl_generator_cpp::MessageInitialization::ALL == _init ||
      rosidl_generator_cpp::MessageInitialization::ZERO == _init)
    {
      this->success = false;
    }
  }

  // field types and members
  using _success_type =
    bool;
  _success_type success;

  // setters for named parameter idiom
  Type & set__success(
    const bool & _arg)
  {
    this->success = _arg;
    return *this;
  }

  // constant declarations

  // pointer types
  using RawPtr =
    ml_classifiers::srv::ClearClassifier_Response_<ContainerAllocator> *;
  using ConstRawPtr =
    const ml_classifiers::srv::ClearClassifier_Response_<ContainerAllocator> *;
  using SharedPtr =
    std::shared_ptr<ml_classifiers::srv::ClearClassifier_Response_<ContainerAllocator>>;
  using ConstSharedPtr =
    std::shared_ptr<ml_classifiers::srv::ClearClassifier_Response_<ContainerAllocator> const>;

  template<typename Deleter = std::default_delete<
      ml_classifiers::srv::ClearClassifier_Response_<ContainerAllocator>>>
  using UniquePtrWithDeleter =
    std::unique_ptr<ml_classifiers::srv::ClearClassifier_Response_<ContainerAllocator>, Deleter>;

  using UniquePtr = UniquePtrWithDeleter<>;

  template<typename Deleter = std::default_delete<
      ml_classifiers::srv::ClearClassifier_Response_<ContainerAllocator>>>
  using ConstUniquePtrWithDeleter =
    std::unique_ptr<ml_classifiers::srv::ClearClassifier_Response_<ContainerAllocator> const, Deleter>;
  using ConstUniquePtr = ConstUniquePtrWithDeleter<>;

  using WeakPtr =
    std::weak_ptr<ml_classifiers::srv::ClearClassifier_Response_<ContainerAllocator>>;
  using ConstWeakPtr =
    std::weak_ptr<ml_classifiers::srv::ClearClassifier_Response_<ContainerAllocator> const>;

  // pointer types similar to ROS 1, use SharedPtr / ConstSharedPtr instead
  // NOTE: Can't use 'using' here because GNU C++ can't parse attributes properly
  typedef DEPRECATED__ml_classifiers__srv__ClearClassifier_Response
    std::shared_ptr<ml_classifiers::srv::ClearClassifier_Response_<ContainerAllocator>>
    Ptr;
  typedef DEPRECATED__ml_classifiers__srv__ClearClassifier_Response
    std::shared_ptr<ml_classifiers::srv::ClearClassifier_Response_<ContainerAllocator> const>
    ConstPtr;

  // comparison operators
  bool operator==(const ClearClassifier_Response_ & other) const
  {
    if (this->success != other.success) {
      return false;
    }
    return true;
  }
  bool operator!=(const ClearClassifier_Response_ & other) const
  {
    return !this->operator==(other);
  }
};  // struct ClearClassifier_Response_

// alias to use template instance with default allocator
using ClearClassifier_Response =
  ml_classifiers::srv::ClearClassifier_Response_<std::allocator<void>>;

// constant definitions

}  // namespace srv

}  // namespace ml_classifiers

namespace ml_classifiers
{

namespace srv
{

struct ClearClassifier
{
  using Request = ml_classifiers::srv::ClearClassifier_Request;
  using Response = ml_classifiers::srv::ClearClassifier_Response;
};

}  // namespace srv

}  // namespace ml_classifiers

#endif  // ML_CLASSIFIERS__SRV__CLEAR_CLASSIFIER__STRUCT_HPP_
