#ifndef _H_809F2AD0F1E056D89E4D8AAA70105F12_TrainClassifier__H_
#define _H_809F2AD0F1E056D89E4D8AAA70105F12_TrainClassifier__H_

#include "sacpp_mapping.h"
#include "cpp_dcps_if.h"


namespace ml_classifiers
{
    namespace srv
    {
        namespace dds_
        {
            struct  TrainClassifier_Request_
            {
                ::DDS::String_mgr identifier_;
            };

            typedef DDS_DCPSStruct_var<TrainClassifier_Request_> TrainClassifier_Request__var;
            typedef DDS_DCPSStruct_out < TrainClassifier_Request_> TrainClassifier_Request__out;

            struct  TrainClassifier_Response_
            {
                ::DDS::Boolean success_;
            };

            typedef DDS_DCPSStruct_var<TrainClassifier_Response_> TrainClassifier_Response__var;
            typedef TrainClassifier_Response_& TrainClassifier_Response__out;

            struct  Sample_TrainClassifier_Request_
            {
                ::DDS::ULongLong client_guid_0_;
                ::DDS::ULongLong client_guid_1_;
                ::DDS::LongLong sequence_number_;
                ::ml_classifiers::srv::dds_::TrainClassifier_Request_ request_;
            };

            typedef DDS_DCPSStruct_var<Sample_TrainClassifier_Request_> Sample_TrainClassifier_Request__var;
            typedef DDS_DCPSStruct_out < Sample_TrainClassifier_Request_> Sample_TrainClassifier_Request__out;

            struct  Sample_TrainClassifier_Response_
            {
                ::DDS::ULongLong client_guid_0_;
                ::DDS::ULongLong client_guid_1_;
                ::DDS::LongLong sequence_number_;
                ::ml_classifiers::srv::dds_::TrainClassifier_Response_ response_;
            };

            typedef DDS_DCPSStruct_var<Sample_TrainClassifier_Response_> Sample_TrainClassifier_Response__var;
            typedef Sample_TrainClassifier_Response_& Sample_TrainClassifier_Response__out;

        }

    }

}

#endif /* _H_809F2AD0F1E056D89E4D8AAA70105F12_TrainClassifier__H_ */
